%%==============================================================================
%% PropEr Custom Generators
%%==============================================================================
-module(els_proper_gen).

%%==============================================================================
%% Includes
%%==============================================================================
-include_lib("proper/include/proper.hrl").

%%==============================================================================
%% Exports
%%==============================================================================
-compile(export_all).

%%==============================================================================
%% Generators
%%==============================================================================
uri() ->
    ?LET(
        B,
        document(),
        els_uri:uri(filename:join([system_tmp_dir(), B ++ ".erl"]))
    ).

root_uri() ->
    els_uri:uri(system_tmp_dir()).

init_options() ->
    #{<<"indexingEnabled">> => false}.

document() ->
    elements(["a", "b", "c"]).

tokens() ->
    ?LET(
        Tokens,
        vector(10, token()),
        begin
            Concatenated = [string:join(Tokens, ","), "."],
            els_utils:to_binary(Concatenated)
        end
    ).

token() ->
    elements(["foo", "Bar", "\"baz\""]).

%%==============================================================================
%% Internal Functions
%%==============================================================================
system_tmp_dir() ->
    els_utils:to_binary(els_utils:system_tmp_dir()).
